'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  for (var _len = arguments.length, fieldNames = Array(_len), _key = 0; _key < _len; _key++) {
    fieldNames[_key] = arguments[_key];
  }

  return function (context) {
    (0, _checkContextIf2.default)(context, 'before', ['create', 'update', 'patch'], 'keep');
    var items = (0, _getItems2.default)(context);

    if (Array.isArray(items)) {
      (0, _replaceItems2.default)(context, items.map(function (item) {
        return replaceItem(item, fieldNames);
      }));
    } else {
      (0, _replaceItems2.default)(context, replaceItem(items, fieldNames));
    }

    return context;
  };
};

var _checkContextIf = require('./check-context-if');

var _checkContextIf2 = _interopRequireDefault(_checkContextIf);

var _getItems = require('./get-items');

var _getItems2 = _interopRequireDefault(_getItems);

var _replaceItems = require('./replace-items');

var _replaceItems2 = _interopRequireDefault(_replaceItems);

var _getByDot = require('../common/get-by-dot');

var _getByDot2 = _interopRequireDefault(_getByDot);

var _setByDot = require('../common/set-by-dot');

var _setByDot2 = _interopRequireDefault(_setByDot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function replaceItem(item, fields) {
  var newItem = {};
  fields.forEach(function (field) {
    var value = (0, _getByDot2.default)(item, field);
    if (value) {
      (0, _setByDot2.default)(newItem, field, value);
    }
  });
  item = newItem;
  return item;
}
module.exports = exports['default'];